using System;
using System.Text.Json.Serialization;
namespace org.accordproject.decoratorcommands {
   using concerto.metamodel;
   using concerto;
   class DecoratorCommandSetReference : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.decoratorcommands.DecoratorCommandSetReference";
      public string name { get; set; }
      public string version { get; set; }
   }
   enum CommandType {
      UPSERT,
      APPEND,
   }

   class CommandTarget : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.decoratorcommands.CommandTarget";
      public string namespace { get; set; }
      public string declaration { get; set; }
      public string property { get; set; }
      public string type { get; set; }
   }
   class Command : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.decoratorcommands.Command";
      public CommandTarget target { get; set; }
      public Decorator decorator { get; set; }
      public CommandType type { get; set; }
   }
   class DecoratorCommandSet : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.decoratorcommands.DecoratorCommandSet";
      public string name { get; set; }
      public string version { get; set; }
      public DecoratorCommandSetReference[] includes { get; set; }
      public Command[] commands { get; set; }
   }
}
